SystemOrganization addCategory: #'Deltawerken-Seaside'!
SystemOrganization addCategory: #'Deltawerken-Seaside-Component'!

DEComponent subclass: #DEEditComponent
	instanceVariableNames: 'expired builder isNew subject infoText title customActions displayTable fieldList original editDivId focus focusId editTableClass footerText fieldComponent checkAll expireAnnouncement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside-Component'!

!DEEditComponent class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 5/2/2011 14:55'!
on: aSubject isNew: aIsNew
	^self basicNew
		initialize: aSubject isNew: aIsNew! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
addCustomAction: aAction
	self builder addCustomAction: aAction! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
addCustomAction: aAction at: aKey
	self builder addCustomAction: aAction at: aKey! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
addCustomUpdater: anUpdater
	self builder addCustomUpdater: anUpdater! !

!DEEditComponent methodsFor: 'call/answer' stamp: 'StephanEggermont 5/2/2011 14:55'!
answerOk
	expired := true.
	self answer: self selected
! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
beReadonly
	self builder beReadonly! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
beWritable
	self builder beWritable! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:40'!
builder
	^builder ifNil: [ builder := DEBuilder new ]! !

!DEEditComponent methodsFor: 'accessing' stamp: 'DiegoLont 3/27/2012 16:17'!
canEdit: aBoolean 
	aBoolean
		ifTrue: [ self beWritable ]
		ifFalse: [ self beReadonly ]! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
checkAll
	checkAll ifNil: [ ^self isNew ].
	^ checkAll! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
checkAll: anObject
	checkAll := anObject! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
createFieldComponent
	self displayTable ifTrue: [ ^self builder createTableComponent ].
	^self builder createDivsComponent! !

!DEEditComponent methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:55'!
displayTable
	displayTable ifNil: [ ^true ].
	^displayTable! !

!DEEditComponent methodsFor: 'call/answer' stamp: 'StephanEggermont 5/2/2011 14:55'!
doCancel
	self answer: nil
! !

!DEEditComponent methodsFor: 'call/answer' stamp: 'StephanEggermont 5/20/2011 15:48'!
doSave
	expired 
		ifTrue: [ self announce: self expireAnnouncement ]
		ifFalse: [ 
			self validate.
			self isValid ifTrue: [ self answerOk ] ]! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
editDivId
	^ editDivId! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
editDivId: anObject
	editDivId := anObject! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
editTableClass
	editTableClass ifNil: [ ^'editTable' ].
	^editTableClass! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
editTableClass: aString
	editTableClass := aString
! !

!DEEditComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 10:31'!
expireAnnouncement
	^expireAnnouncement ifNil: [ expireAnnouncement := DEExpired ]
! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
fieldComponent
	^fieldComponent ifNil: [ 
		fieldComponent := self createFieldComponent ]! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
focus: anObject
	focus := anObject! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
focusId
	^focusId! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
focusId: aString
	focusId := aString! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
footerText
	^ footerText! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
footerText: anObject
	footerText := anObject! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
hasRequiredField
	^self fieldComponent hasRequiredFieldFor: self subject! !

!DEEditComponent methodsFor: 'accessing' stamp: 'DiegoLont 2/14/2012 14:52'!
hasValidation
	^self fieldComponent hasValidation! !

!DEEditComponent methodsFor: 'accessing' stamp: 'DiegoLont 2/14/2012 14:52'!
hasValidation: aBoolean
	self fieldComponent hasValidation: aBoolean! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
infoText
	^infoText
! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
infoText: aText
	infoText := aText
! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
initialize: aSubject isNew: aIsNew
	self initialize.
	self subject: aSubject isNew: aIsNew! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
isNew
	isNew ifNil: [ ^true ].
	^isNew! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
isNew: anObject
	isNew := anObject! !

!DEEditComponent methodsFor: 'call/answer' stamp: 'StephanEggermont 5/2/2011 14:55'!
isValid
	self checkAll
		ifTrue: [
			^self fieldComponent isValid: subject ]
		ifFalse: [
			^self fieldComponent isValid: subject original: original ]
			
! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
original
	^original! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
propertySymbol
	^self builder propertySymbol
! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
propertySymbol: aSymbol
	self builder propertySymbol: aSymbol
! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
readonly
	^self builder readonly! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
removeCustomActions
	self builder removeCustomActions! !

!DEEditComponent methodsFor: 'rendering' stamp: 'DiegoLont 3/27/2012 16:19'!
renderContentOn: canvas
	self renderTitleOn: canvas.

	self infoText ifNotNil: [ 
		canvas div
			class: 'infoText';
			with: self infoText ].
	self renderFormDataOn: canvas.
	self footerText ifNotNil: [
		canvas div
			class: 'infoText';
			with: self footerText ].

	self setFocusOn: canvas! !

!DEEditComponent methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:55'!
renderFieldComponentOn: canvas 
	self subject ifNotNil: [
		self fieldComponent renderContentFor: self subject on: canvas ]! !

!DEEditComponent methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:55'!
renderFormDataOn: canvas
	| brush |
	brush := canvas div
		class: self editTableClass;
		yourself.
	editDivId ifNotNil: [ brush id: editDivId ].
	brush with: [ self renderFieldComponentOn: canvas ]! !

!DEEditComponent methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:55'!
renderTitleOn: canvas
	self title ifNotNil: [
		canvas div
			class: 'title';
			with: [ canvas heading
				level: 2;
				with: self title ] ].
! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
requiredStar
	^self builder requiredStar! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
requiredStar: aBoolean
	self builder requiredStar: aBoolean! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
selected
	^self subject! !

!DEEditComponent methodsFor: 'rendering' stamp: 'StephanEggermont 9/3/2012 22:12'!
setFocusOn: canvas
	focusId ifNotNil: [ 
		" setting focus is always single-shot "
		canvas script: 'document.getElementById("', focusId, '").focus();'.
		focusId := nil ]! !

!DEEditComponent methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:55'!
showAsDiv
	self displayTable ifTrue: [ fieldComponent := nil ].
	displayTable := false! !

!DEEditComponent methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:55'!
showAsTable
	self displayTable ifFalse: [ fieldComponent := nil ].
	displayTable := true! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
subject
	^subject! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
subject: aSubject isNew: aIsNew 
	self isNew: aIsNew.
	isNew 
		ifTrue: [ subject := aSubject ]
		ifFalse: [ 
			subject := aSubject copy.
			original := aSubject ].
	expired := false.
	fieldComponent ifNotNil: [ self fieldComponent clearCache ]! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
title
	^title
! !

!DEEditComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
title: aTitle
	title := aTitle
! !

!DEEditComponent methodsFor: 'call/answer' stamp: 'StephanEggermont 5/2/2011 14:55'!
validate
	^self fieldComponent validate: subject
! !

DEEditComponent subclass: #DEEditForm
	instanceVariableNames: 'form saveTextNew saveTextExisting saveButton hasCancel cancelButton saveAction requiredText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside-Component'!

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
addButton: aButton
	self form addButton: aButton! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/20/2011 15:50'!
answerOk
	self saveAction 
		ifNil: [ super answerOk ]
		ifNotNil: [ saveAction value ]! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
beReadonly
	super beReadonly.
	self updateButtons! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
beWritable
	super beWritable.
	self updateButtons! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
cancelAction: anAction
	self cancelButton action: anAction.
	self hasCancel: true! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
cancelButton
	^cancelButton ifNil: [ cancelButton := self createCancelButton ]! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
cancelText
	self cancelButton label! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
cancelText: anObject
	self cancelButton label: anObject! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:42'!
createButton
	^DEActionButton new
! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
createCancelButton
	^self createButton
		label: 'Cancel';
		beCancelAction;
		action: [ self doCancel ];
		yourself! !

!DEEditForm methodsFor: 'initialization' stamp: 'StephanEggermont 5/2/2011 15:45'!
createFormDecoration
	^DEFormDecoration new! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
createSaveButton
	^self createButton
		label: self saveText;
		action: [ self doSave ];
		yourself! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
form
	^form ifNil: [ form := self createFormDecoration ]! !

!DEEditForm methodsFor: 'accessing' stamp: 'DiegoLont 12/21/2011 11:24'!
formClass: aString 
	self form formClass: aString! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
formId
	^self form formId! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
formId: aString
	^self form formId: aString! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
hasCancel
	hasCancel ifNil: [ ^true ].
	^hasCancel! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
hasCancel: anObject 
	hasCancel := anObject.
	self updateButtons! !

!DEEditForm methodsFor: 'initialization' stamp: 'StephanEggermont 5/2/2011 14:55'!
initialize
	super initialize.
	self addDecoration: self form.
	self updateButtons! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
isNew: anObject
	super isNew: anObject.
	saveButton label: self saveText
! !

!DEEditForm methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:55'!
renderContentOn: canvas
	super renderContentOn: canvas.
	self renderRequiredTextOn: canvas! !

!DEEditForm methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:55'!
renderRequiredTextOn: canvas
	self requiredText ifNotNil: [
		self hasRequiredField ifTrue: [
			canvas div
				class: self requiredClass;
				with: [
					canvas span
						class: 'field-required';
						with: '*'.
					canvas render: self requiredText ] ] ]! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
requiredClass
	^'requiredText'! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
requiredText
	^ requiredText! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
requiredText: anObject
	requiredText := anObject! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
saveAction
	^ saveAction! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
saveAction: anObject
	saveAction := anObject! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
saveButton
	^saveButton ifNil: [ saveButton := self createSaveButton ]! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
saveButton: aButton
	saveButton := aButton! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
saveText
	self isNew ifTrue: [ ^self saveTextNew ].
	^self saveTextExisting
! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
saveTextExisting
	^ saveTextExisting ifNil: [ saveTextExisting := 'Save' ]! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
saveTextExisting: anObject
	saveTextExisting := anObject.
	saveButton label: self saveText! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
saveTextNew
	^ saveTextNew ifNil: [ saveTextNew := 'Add' ]! !

!DEEditForm methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:55'!
saveTextNew: anObject
	saveTextNew := anObject.
	saveButton label: self saveText! !

!DEEditForm methodsFor: 'initialization' stamp: 'StephanEggermont 5/2/2011 14:55'!
updateButtons
	self readonly 
		ifTrue: [ self form defaultButton: self cancelButton ]
		ifFalse: 
			[ self form defaultButton: self saveButton.
			self hasCancel 
				ifTrue: [ self form addButton: self cancelButton ]
				ifFalse: [ self form removeButton: self cancelButton ] ]! !

WAFileLibrary subclass: #DEFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside'!

!DEFileLibrary methodsFor: 'uploaded' stamp: 'StephanEggermont 5/2/2011 15:19'!
StoryPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 14 8 6 0 0 0 38 47 156 138 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 219 2 14 10 11 56 232 83 134 156 0 0 0 34 116 69 88 116 67 111 109 109 101 110 116 0 67 114 101 97 116 101 100 32 119 105 116 104 32 71 73 77 80 32 111 110 32 97 32 77 97 99 135 168 119 67 0 0 0 134 73 68 65 84 40 207 157 82 49 14 128 32 12 108 77 39 159 227 74 124 2 187 79 116 134 23 16 157 253 75 23 87 28 76 141 32 96 195 77 215 66 239 46 77 49 132 176 51 179 129 20 7 0 76 160 0 49 179 177 246 204 251 170 97 239 71 32 41 16 231 231 33 198 45 169 165 87 76 80 251 80 27 40 10 32 46 208 3 231 220 45 16 227 218 37 224 61 252 239 160 197 213 59 168 241 68 64 155 34 23 162 214 230 91 206 130 225 237 46 46 53 174 190 3 141 243 39 65 47 72 110 186 23 23 156 116 82 249 96 181 0 124 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!DEFileLibrary methodsFor: 'uploaded' stamp: 'StephanEggermont 5/2/2011 15:19'!
infoPng
	| cache |
	cache := #(nil) beMutable.
	(cache first) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 12 0 0 0 12 8 6 0 0 0 86 117 92 231 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 219 3 1 11 23 24 81 139 168 216 0 0 1 180 73 68 65 84 40 207 69 145 61 107 83 113 24 197 127 207 255 222 155 87 19 67 37 137 145 70 65 10 186 180 88 28 252 8 46 221 138 32 168 29 28 196 124 0 253 26 14 46 130 175 93 212 177 139 147 136 160 160 21 68 164 20 170 139 131 196 154 72 160 134 24 147 155 255 203 227 144 164 30 56 195 129 195 225 28 142 48 67 114 229 117 193 38 11 45 10 199 110 23 19 173 33 252 29 218 248 61 127 186 15 217 60 247 108 238 19 0 174 239 156 146 56 183 87 169 55 243 153 76 142 90 113 160 128 116 6 37 188 27 115 240 171 253 85 191 125 94 225 229 165 73 156 92 125 83 112 113 110 239 248 201 165 124 198 4 205 199 7 178 115 99 65 0 150 238 14 113 73 86 179 139 167 207 252 84 253 8 172 24 27 149 110 150 171 205 124 68 80 235 85 130 114 8 175 138 245 42 145 168 30 173 54 151 217 248 116 89 104 125 239 84 27 139 117 81 15 8 35 23 97 195 108 151 129 124 236 1 37 32 244 186 157 183 38 155 72 29 17 245 42 120 85 26 71 58 108 173 175 177 181 190 70 173 208 195 171 226 85 64 34 114 177 94 136 125 0 235 129 89 106 33 30 112 113 245 5 0 217 87 67 252 168 114 88 209 5 177 198 57 215 182 206 139 11 168 11 96 131 1 7 56 112 94 112 1 92 0 107 29 206 251 109 35 233 239 59 147 241 152 160 224 195 148 200 148 115 29 84 52 77 83 100 212 123 96 140 79 239 185 254 143 116 226 17 175 70 5 7 17 16 77 167 122 53 58 113 65 124 191 189 171 79 206 63 23 0 185 182 221 32 87 249 34 165 19 229 56 147 165 81 238 42 168 236 247 235 120 59 65 7 251 187 122 255 236 242 255 167 1 179 241 161 168 81 182 69 166 116 75 162 164 6 50 210 96 223 145 246 31 233 227 213 167 115 223 63 130 198 217 199 90 80 67 203 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache first! !

!DEFileLibrary methodsFor: 'uploaded' stamp: 'StephanEggermont 5/2/2011 15:19'!
minGif
	^#(71 73 70 56 57 97 22 0 21 0 198 87 0 241 241 241 235 235 235 240 240 240 224 224 224 238 238 238 233 233 233 3 115 243 239 239 239 236 236 236 227 227 227 229 229 229 232 232 232 223 223 223 230 230 230 231 231 231 222 222 222 226 226 226 254 254 254 251 251 251 149 196 250 254 254 255 112 175 248 252 253 255 252 252 252 76 156 246 165 205 251 228 240 254 118 179 248 85 161 247 236 245 254 196 222 252 65 150 246 7 117 243 12 120 243 80 158 247 109 174 248 131 186 249 168 207 251 94 166 247 241 247 254 108 173 248 148 196 250 71 153 246 18 123 244 43 137 245 249 252 255 59 146 246 250 250 250 217 234 253 72 153 246 194 221 252 221 236 253 171 208 251 235 244 254 238 246 254 213 231 253 214 232 253 64 149 246 145 194 250 69 152 246 26 128 244 20 124 244 45 138 245 136 189 249 242 248 254 5 116 243 250 252 255 187 217 252 247 251 255 54 144 245 101 169 248 24 127 244 233 243 254 224 238 254 42 136 245 237 237 237 228 228 228 225 225 225 234 234 234 245 245 245 242 242 242 246 246 246 243 243 243 244 244 244 247 247 247 248 248 248 249 249 249 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 44 0 0 0 0 22 0 21 0 0 7 254 128 86 130 86 85 85 81 79 83 82 80 0 80 82 83 81 84 85 131 147 85 84 79 82 2 75 1 5 5 78 1 4 0 143 133 148 84 83 0 8 11 76 77 15 15 12 16 10 78 4 82 79 145 130 149 83 2 78 170 14 80 87 87 81 75 170 13 75 80 79 146 132 79 0 78 9 76 81 190 207 190 75 3 10 75 82 81 133 81 82 8 76 76 18 208 223 2 12 14 7 83 145 79 2 14 3 84 223 236 11 77 78 0 215 83 193 11 190 22 236 207 86 76 13 228 84 80 1 3 164 224 99 71 32 1 2 41 254 10 60 120 97 160 161 195 135 14 175 12 8 128 16 128 66 136 24 31 14 112 2 197 159 19 6 84 50 98 188 210 132 34 21 41 1 32 16 24 8 45 130 174 37 83 170 76 33 160 32 65 4 150 190 160 52 89 32 192 88 20 101 3 86 178 35 226 235 2 4 38 7 169 88 41 69 160 193 0 0 3 47 40 120 215 83 146 33 40 75 20 48 40 96 165 37 148 4 77 10 244 59 86 229 9 86 7 77 18 44 241 101 177 9 19 39 44 228 174 13 170 116 233 128 147 6 96 7 184 93 128 64 128 168 73 132 12 77 129 114 0 65 0 79 75 4 204 170 5 216 22 149 67 137 26 77 161 53 106 80 32 0 59) asByteArray! !

!DEFileLibrary methodsFor: 'uploaded' stamp: 'StephanEggermont 5/2/2011 15:19'!
minPng
	^#(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 20 0 0 0 20 8 6 0 0 0 141 137 29 13 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 218 11 2 14 1 4 182 64 180 33 0 0 2 47 73 68 65 84 56 203 165 149 79 107 212 64 24 135 159 230 79 147 221 118 150 118 41 20 122 208 195 130 176 248 5 132 66 7 4 191 129 224 73 138 71 207 30 68 84 240 160 224 69 240 32 120 20 47 130 208 111 32 8 51 44 8 11 178 126 0 175 118 41 84 210 109 38 13 201 118 18 47 237 186 105 211 88 236 11 63 8 188 239 60 204 188 239 228 55 11 101 89 82 23 90 235 199 192 54 112 29 104 3 22 248 1 124 7 118 164 148 95 234 214 45 156 5 106 173 223 2 219 171 171 171 43 107 107 107 8 33 88 90 90 2 32 73 18 226 56 102 127 127 159 40 138 20 240 94 74 249 185 2 40 203 114 38 165 212 96 56 28 150 81 20 149 69 81 52 42 138 162 114 56 28 150 74 169 151 181 64 165 212 96 52 26 149 89 150 149 214 218 75 41 203 178 114 52 26 85 160 206 233 49 195 48 220 236 247 251 184 174 91 217 117 147 92 215 165 223 239 19 134 225 83 165 212 189 25 16 216 238 245 122 56 142 67 81 20 231 148 101 25 89 150 213 230 28 199 161 215 235 1 60 4 240 180 214 143 58 157 206 138 16 130 139 38 62 223 158 186 16 66 208 233 116 164 82 234 182 7 60 232 118 187 20 69 193 191 162 169 166 219 237 114 120 120 120 215 3 110 8 33 174 12 20 66 0 220 241 0 223 243 188 74 241 202 11 46 21 7 115 117 158 231 1 92 243 128 242 248 248 120 193 117 221 185 82 231 82 192 249 77 88 107 1 82 15 200 243 60 15 194 48 156 37 127 63 183 149 133 190 239 3 48 157 78 207 12 233 239 119 158 231 0 191 60 224 103 28 199 55 23 23 23 175 212 195 56 142 1 148 3 124 152 76 38 181 119 236 84 243 192 139 52 153 76 0 118 156 173 173 173 55 73 146 28 24 99 254 27 104 140 33 73 18 37 165 252 122 218 253 143 227 241 24 107 109 237 47 102 140 193 24 83 155 179 214 50 30 143 1 222 87 236 75 107 253 173 213 106 221 218 216 216 160 58 241 139 195 90 203 238 238 46 105 154 190 150 82 62 57 231 135 90 235 129 239 251 155 235 235 235 180 90 173 70 88 154 166 236 237 237 49 157 78 95 73 41 159 53 25 236 59 224 126 187 221 238 44 47 47 19 4 1 65 16 0 204 76 194 24 195 209 209 209 224 196 96 63 53 58 118 195 19 192 137 253 55 62 1 127 0 84 104 5 196 113 70 244 152 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!DEFileLibrary methodsFor: 'uploaded' stamp: 'StephanEggermont 5/2/2011 15:19'!
plusGif
	^#(71 73 70 56 57 97 22 0 21 0 198 87 0 241 241 241 235 235 235 240 240 240 224 224 224 238 238 238 233 233 233 3 115 243 239 239 239 236 236 236 227 227 227 229 229 229 232 232 232 223 223 223 230 230 230 231 231 231 222 222 222 226 226 226 254 254 254 251 251 251 149 196 250 254 254 255 112 175 248 252 253 255 252 252 252 76 156 246 165 205 251 228 240 254 118 179 248 85 161 247 236 245 254 196 222 252 65 150 246 7 117 243 12 120 243 80 158 247 109 174 248 131 186 249 168 207 251 94 166 247 241 247 254 108 173 248 148 196 250 71 153 246 18 123 244 43 137 245 249 252 255 59 146 246 250 250 250 217 234 253 72 153 246 194 221 252 221 236 253 171 208 251 235 244 254 238 246 254 213 231 253 214 232 253 64 149 246 145 194 250 69 152 246 26 128 244 20 124 244 45 138 245 136 189 249 242 248 254 5 116 243 250 252 255 187 217 252 247 251 255 54 144 245 101 169 248 24 127 244 233 243 254 224 238 254 42 136 245 237 237 237 228 228 228 225 225 225 234 234 234 245 245 245 242 242 242 246 246 246 243 243 243 244 244 244 247 247 247 248 248 248 249 249 249 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 255 44 0 0 0 0 22 0 21 0 0 7 254 128 86 130 86 85 85 81 79 83 82 80 0 80 82 83 81 84 85 131 147 85 84 79 82 2 75 1 5 5 78 1 4 0 143 133 148 84 83 0 8 11 76 77 15 15 12 16 10 78 4 82 79 145 130 149 83 2 78 170 14 80 86 6 81 75 170 13 75 80 79 146 132 79 0 78 9 76 81 87 87 6 209 207 75 3 10 75 82 81 133 81 82 8 76 76 18 207 208 210 207 2 12 14 7 83 145 79 2 14 3 84 225 226 6 240 11 77 78 0 217 83 193 11 207 22 207 209 242 225 172 48 105 128 142 10 148 0 3 164 192 139 183 144 64 2 4 82 12 22 120 240 226 159 197 139 242 6 4 136 8 96 34 198 143 209 6 56 129 98 208 9 3 42 32 47 94 105 178 145 138 148 0 16 8 44 252 7 47 130 174 37 83 170 76 33 160 32 65 4 120 52 195 65 105 178 64 128 177 40 202 6 200 12 247 143 200 179 11 16 152 64 164 98 165 20 129 6 3 0 48 29 119 65 65 61 163 146 12 65 89 162 128 65 1 43 241 34 64 73 208 164 64 193 99 58 85 158 140 117 208 36 193 18 104 29 155 48 113 130 46 219 160 74 151 14 56 105 192 118 128 222 5 8 4 136 154 68 200 208 20 40 7 16 4 240 180 68 192 172 90 140 109 81 57 148 168 209 20 90 163 6 5 2 0 59) asByteArray! !

!DEFileLibrary methodsFor: 'uploaded' stamp: 'StephanEggermont 5/2/2011 15:19'!
plusPng
	^#(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 20 0 0 0 20 8 6 0 0 0 141 137 29 13 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 218 11 2 13 58 13 241 104 93 228 0 0 2 56 73 68 65 84 56 203 165 149 207 106 212 80 20 198 127 77 50 77 102 218 27 218 177 80 232 66 23 3 194 224 11 8 133 94 16 124 3 193 149 20 151 174 133 22 241 15 130 10 110 4 23 66 151 226 70 16 124 3 65 184 151 1 97 64 198 7 112 235 12 133 74 58 77 50 33 211 222 92 55 109 153 216 52 45 250 193 183 201 57 231 227 220 115 110 190 59 103 173 165 10 90 235 109 96 19 184 6 180 0 3 252 0 190 3 159 165 148 95 170 234 230 254 22 212 90 191 5 54 151 151 151 151 86 86 86 16 66 176 176 176 0 64 154 166 196 113 204 222 222 30 81 20 41 96 71 74 249 169 36 96 173 61 165 82 170 215 239 247 109 20 69 182 40 138 90 70 81 100 251 253 190 85 74 189 172 20 84 74 245 6 131 129 205 243 220 26 99 46 197 60 207 237 96 48 40 137 58 39 199 12 130 96 189 219 237 226 186 110 169 235 58 186 174 75 183 219 37 8 130 199 74 169 187 167 130 192 102 167 211 193 113 28 138 162 56 67 127 59 195 223 206 42 99 142 227 208 233 116 0 30 0 120 90 235 135 97 24 46 9 33 56 111 227 179 227 169 130 16 130 48 12 165 82 234 150 7 220 111 183 219 20 69 193 69 168 203 105 183 219 28 28 28 220 241 128 235 66 136 255 22 20 66 0 220 246 128 134 231 121 165 228 165 231 213 69 225 179 178 224 254 76 158 231 121 0 87 61 192 30 29 29 205 185 174 59 147 234 112 25 204 54 97 140 1 200 60 96 58 157 78 253 32 8 78 131 191 159 154 82 225 149 23 110 229 247 217 29 77 167 83 128 95 30 240 51 142 227 27 243 243 243 53 189 184 23 206 48 142 99 0 229 0 239 199 227 113 229 29 59 225 236 17 207 227 120 60 6 248 236 108 108 108 188 73 211 116 63 73 146 127 22 76 146 132 52 77 149 148 242 235 201 244 63 140 70 35 140 49 149 191 216 112 107 194 112 107 82 25 51 198 48 26 141 0 118 74 246 165 181 254 214 108 54 111 174 173 173 81 222 248 249 48 198 48 28 14 201 178 236 181 148 242 209 25 63 212 90 247 26 141 198 250 234 234 42 205 102 179 86 44 203 50 118 119 119 57 60 60 124 37 165 124 82 103 176 239 128 123 173 86 43 92 92 92 196 247 125 124 223 7 32 207 115 242 60 39 73 18 38 147 73 239 216 96 63 214 58 118 205 19 192 177 253 215 62 1 127 0 126 31 3 81 120 4 165 41 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!DEFileLibrary methodsFor: 'uploaded' stamp: 'StephanEggermont 5/2/2011 15:19'!
starPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 24 0 0 0 24 8 6 0 0 0 224 119 61 248 0 0 0 1 115 82 71 66 0 174 206 28 233 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 0 7 116 73 77 69 7 219 2 14 10 32 47 29 240 254 50 0 0 0 34 116 69 88 116 67 111 109 109 101 110 116 0 67 114 101 97 116 101 100 32 119 105 116 104 32 71 73 77 80 32 111 110 32 97 32 77 97 99 135 168 119 67 0 0 5 213 73 68 65 84 72 199 117 150 91 108 156 87 17 199 127 243 93 188 187 222 93 219 113 28 95 82 39 217 36 164 78 218 168 45 117 26 37 168 165 134 66 16 164 82 21 169 40 21 151 68 66 20 137 8 129 80 31 104 37 20 210 242 192 11 68 60 84 109 5 136 7 64 244 13 84 33 209 7 30 90 80 26 37 36 37 113 226 58 23 131 107 199 142 119 237 248 178 187 94 239 197 223 119 102 120 88 71 74 12 29 105 116 230 28 105 102 254 115 102 206 204 193 204 122 204 140 187 172 170 168 42 166 206 87 179 31 173 174 44 107 245 252 59 186 244 222 31 117 49 63 85 110 56 59 173 170 91 204 204 95 175 119 175 254 93 70 85 189 245 135 166 14 51 245 34 179 99 213 127 189 107 250 221 30 139 191 138 205 254 246 101 43 204 47 90 195 236 117 83 221 181 30 212 255 99 15 80 214 147 25 32 190 70 113 93 111 93 198 22 103 241 231 33 253 143 183 88 57 247 23 74 53 61 238 68 94 5 6 238 209 18 49 243 69 85 196 185 80 84 67 129 108 192 39 147 83 231 242 42 134 102 67 60 63 34 173 69 178 103 94 167 220 183 59 147 120 108 255 179 109 30 195 152 157 22 211 24 216 131 231 191 6 44 43 44 2 203 30 100 3 17 89 7 222 238 138 45 168 14 98 177 73 210 53 79 218 160 179 126 129 250 153 95 177 180 41 151 9 183 116 127 51 37 82 119 226 23 98 248 186 91 169 61 235 166 38 137 242 121 36 157 38 28 24 32 48 51 68 228 94 195 77 71 208 130 139 62 235 215 150 68 178 10 1 88 224 225 119 41 155 10 111 51 243 222 67 44 12 29 123 184 61 212 95 250 133 9 226 233 49 26 195 151 168 189 127 158 232 204 69 108 231 14 228 149 87 8 238 53 126 159 12 135 65 142 168 31 64 22 72 2 119 12 146 144 236 175 210 61 250 11 170 115 195 104 224 72 78 157 163 101 236 63 232 21 88 153 4 1 116 116 148 226 181 235 4 102 38 107 215 228 129 165 69 36 68 252 99 49 188 28 89 11 82 94 128 16 200 128 204 27 86 2 217 5 25 157 33 51 243 59 240 129 16 156 7 4 144 76 67 125 5 74 79 62 133 13 13 17 136 72 18 120 82 225 132 67 186 35 216 206 252 108 159 46 220 130 27 127 167 165 240 55 188 46 160 21 72 1 69 160 14 244 2 45 192 20 216 4 232 170 144 220 105 104 4 249 220 110 170 39 190 199 230 253 79 204 5 10 63 141 99 29 138 243 163 131 150 31 193 22 111 226 21 71 9 139 151 9 170 55 240 123 128 141 205 202 149 54 144 169 53 39 53 176 107 32 211 64 26 194 65 96 12 238 100 187 41 31 63 65 223 23 191 48 215 157 78 191 17 196 75 133 151 236 131 55 241 71 222 193 91 186 73 16 215 144 14 160 19 232 106 162 180 106 51 235 230 3 85 224 35 192 53 101 219 1 178 219 131 105 101 110 58 205 157 47 125 139 206 231 143 208 219 217 241 135 148 217 91 65 148 31 181 244 187 175 65 1 232 105 162 161 65 115 63 3 166 64 4 178 102 144 42 48 11 214 9 60 2 236 16 40 41 229 143 224 246 174 231 72 124 237 27 108 222 210 247 231 140 217 207 61 223 95 242 180 173 95 74 123 95 144 90 39 66 5 161 140 16 35 36 17 178 136 180 34 164 214 246 1 2 8 225 218 26 33 226 68 88 66 26 165 164 68 253 187 164 189 175 87 50 129 255 107 207 243 10 192 170 255 227 159 157 62 85 123 96 31 203 155 30 165 146 238 98 213 192 171 46 16 68 10 237 192 150 181 132 118 3 49 80 2 182 130 164 128 143 129 50 72 26 188 59 49 245 9 135 62 114 128 204 214 205 31 39 68 206 3 230 191 250 147 147 219 195 108 103 209 182 62 158 107 236 120 138 70 223 32 43 237 143 81 137 187 144 153 37 18 203 101 164 179 249 48 100 28 68 129 61 32 57 144 24 162 17 88 189 237 209 18 26 254 248 45 202 229 0 125 226 224 158 214 76 106 147 15 211 254 169 83 167 46 123 216 112 202 183 92 38 149 204 37 123 115 176 99 144 234 192 231 104 184 46 90 111 156 197 239 168 33 17 112 3 172 11 164 183 89 251 108 104 38 127 229 138 81 205 251 132 206 112 215 111 82 105 239 75 135 131 159 62 152 240 188 94 255 228 201 147 69 17 153 240 60 111 204 243 100 46 20 155 78 75 188 154 108 207 110 182 176 141 224 250 95 9 101 14 22 193 22 65 182 173 85 208 37 136 174 55 29 132 9 104 204 26 141 5 240 230 26 68 211 147 52 30 218 75 203 246 220 158 192 57 135 239 251 0 231 69 228 34 34 57 241 253 199 91 224 165 20 209 160 175 141 102 111 44 130 116 8 212 12 119 9 110 215 6 88 150 110 82 87 174 145 41 205 227 57 208 122 179 234 18 87 70 168 189 249 6 197 220 214 102 179 83 85 60 207 115 107 216 110 138 234 2 30 3 160 131 126 185 2 101 192 19 104 53 220 48 140 39 14 48 127 244 251 36 183 237 196 198 39 89 190 120 129 240 194 251 36 74 31 226 161 205 1 51 124 153 106 161 64 160 170 172 111 217 107 61 253 67 51 39 82 142 97 22 72 27 58 14 83 153 79 113 231 232 15 216 120 232 48 221 109 173 216 103 246 81 63 252 121 106 55 159 167 113 117 4 61 247 1 241 228 36 60 253 52 237 61 61 205 8 254 135 196 107 174 149 34 86 140 176 2 68 13 152 77 118 144 63 122 130 206 161 103 232 79 39 42 41 211 179 226 100 66 219 59 22 26 7 246 231 106 251 247 61 88 255 242 161 193 184 84 34 216 176 129 76 91 27 193 186 33 115 151 178 2 131 22 57 171 222 170 194 85 88 236 18 242 47 190 72 230 43 71 232 219 208 254 118 42 240 127 239 249 254 89 32 242 205 86 83 206 245 164 84 183 184 254 254 71 181 191 255 160 56 183 77 204 134 168 84 42 212 235 117 137 227 56 233 156 107 113 206 61 168 81 244 66 108 118 177 52 49 110 51 207 61 99 255 110 15 237 159 223 249 182 93 190 58 98 11 181 218 159 162 40 218 171 106 193 125 191 16 51 76 85 204 57 44 142 19 234 156 175 170 7 165 82 169 16 4 65 91 16 4 15 139 72 3 152 18 8 241 188 67 141 70 227 248 210 216 216 80 177 48 139 215 215 203 198 7 30 160 173 181 245 135 97 24 254 70 68 42 159 16 253 125 57 253 47 243 32 51 23 136 249 205 26 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

WAReportColumn subclass: #DEDivColumn
	instanceVariableNames: 'columnClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside'!

!DEDivColumn methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:46'!
columnClass
	^ columnClass! !

!DEDivColumn methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:46'!
columnClass: anObject
	columnClass := anObject! !

DEDivColumn subclass: #DEReportColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside'!

!DEReportColumn methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:47'!
canRender
	^(self formatBlock numArgs > 1) or: [ super canRender ]! !

!DEReportColumn methodsFor: 'public' stamp: 'StephanEggermont 5/2/2011 14:47'!
canSort
	^self sortBlock notNil! !

!DEReportColumn methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:47'!
formatBlock
	^ formatBlock! !

!DEReportColumn methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:47'!
renderValue: row on: html
	(self formatBlock numArgs > 1)
		ifTrue: [ self formatBlock value: (self valueForRow: row) value: html ]
		ifFalse: [ super renderValue: row on: html ]
! !

!DEReportColumn methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:47'!
sortBlock
	^sortBlock! !

WATableReport subclass: #DETableReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside'!

DETableReport subclass: #DEDivReport
	instanceVariableNames: 'reportClass itemClass columnClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside'!

!DEDivReport methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:49'!
columnClass
	columnClass ifNil: [ ^'Field' ].
	^ columnClass! !

!DEDivReport methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:49'!
columnClass: anObject
	columnClass := anObject! !

!DEDivReport methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:49'!
columnClassFor: aColumn
	((aColumn respondsTo: #columnClass) and: [ aColumn columnClass notNil ])
		ifTrue: [ ^aColumn columnClass ].
	columnClass ifNil: [ ^'no-field' ].
	^ columnClass! !

!DEDivReport methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:49'!
itemClass
	itemClass ifNil: [ ^'no-item' ].
	^itemClass! !

!DEDivReport methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:49'!
itemClass: aString
	itemClass := aString! !

!DEDivReport methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:49'!
renderColumn: aColumn row: aRow on: html
	html div
		class: (self columnClassFor: aColumn);
		with: [ aColumn canChoose
			ifFalse: [ self renderContentColumn: aColumn row: aRow on: html ]
			ifTrue: [
				html anchor
					callback: [ self chooseRow: aRow column: aColumn ];
					with: [ self renderContentColumn: aColumn row: aRow on: html ] ] ]! !

!DEDivReport methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:49'!
renderContentOn: html
	html div
		class: self reportClass;
		with: [ self renderRowsOn: html ]! !

!DEDivReport methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:49'!
renderRowNumber: index item: row on: html
	html div
		class: self itemClass;
		with: [
			columns do: [ :each |
				self renderColumn: each row: row on: html ] ]! !

!DEDivReport methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:49'!
reportClass
	reportClass ifNil: [ ^'no-report' ].
	^reportClass! !

!DEDivReport methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:49'!
reportClass: aString
	reportClass := aString! !

!DETableReport methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:49'!
columns
	^columns! !

!DETableReport methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:49'!
renderColumn: aColumn row: aRow on: html
	| brush |
	brush := html tableData.
	aColumn columnClass ifNotNil: [ brush class: aColumn columnClass ].
	brush with: [
		aColumn canChoose
			ifFalse: [ self renderContentColumn: aColumn row: aRow on: html ]
			ifTrue: [
				html anchor
					callback: [ self chooseRow: aRow column: aColumn ];
					with: [ self renderContentColumn: aColumn row: aRow on: html ] ] ]! !

!DETableReport methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:49'!
renderContentColumn: aColumn row: aRow on: html
	| text |
	aColumn canRender ifTrue: [ ^aColumn renderValue: aRow on: html ].
	text := aColumn textForRow: aRow.
	text isEmpty ifTrue: [ text := ' ' ].
	html text: text! !

WAComponent subclass: #DEFieldComponent
	instanceVariableNames: 'cachedFields cacheClass builder requiredStar panel showBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside-Component'!

!DEFieldComponent class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 5/2/2011 14:56'!
on: aBuilder
	^self basicNew
		initialize: aBuilder;
		yourself! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
actionFor: aField
	^self builder customActionFor: aField key ifAbsent: [ aField defaultAction ]! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
addCustomAction: actionButton
	self builder addCustomAction: actionButton! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
addCustomAction: actionButton at: aKey
	self builder addCustomAction: actionButton at: aKey! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
addCustomUpdater: anUpdater
	self builder addCustomUpdater: anUpdater! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
beReadonly
	self builder beReadonly! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
beWritable
	self builder beWritable! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
builder
	^builder ifNil: [ builder := self createBuilder ]! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'DiegoLont 9/26/2012 16:40'!
cacheField: aField
	| key |
	key := aField key.
	^self cachedFields at: key ifAbsent: [
		self cachedFields 
			at: key 
			put: (aField
				updater: (self customUpdaterFor: key);
				yourself) ]! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
cachedFields
	^ cachedFields ifNil: [ cachedFields := Dictionary new ]! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
clearCache
	cachedFields := nil! !

!DEFieldComponent methodsFor: 'initialization' stamp: 'StephanEggermont 5/2/2011 15:14'!
createBuilder
	^DEBuilder new! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
customActionFor: aField
	^self builder customActionFor: aField! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
customActions
	^self builder customActions! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
customUpdaterFor: aKey
	^self builder customUpdaterFor: aKey! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
customUpdaters
	^self builder customUpdaters! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
fieldFor: aSubjectClass symbol: aSymbol
	cacheClass = aSubjectClass ifFalse: [ 
		self clearCache.
		cacheClass := aSubjectClass
	].
	^self cachedFields at: aSymbol ifAbsent: [
		self cachedFields 
			at: aSymbol 
			put: ((aSubjectClass perform: aSymbol)
				key: aSymbol;
				updater: (self customUpdaterFor: aSymbol);
				yourself) ]! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'DiegoLont 12/22/2011 11:43'!
fieldsFor: aSubject
	| subjectClass |
	subjectClass := aSubject class.
	^(subjectClass perform: self propertySymbol) collect: [ :each |
		each isSymbol ifTrue: [ self fieldFor: subjectClass symbol: each ]
			ifFalse: [ each ] ].! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
hasRequiredFieldFor: aSubject
	^self hasRequiredFieldIn: (self fieldsFor: aSubject)! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
hasRequiredFieldIn: aFieldList
	aFieldList do: [ :each |
		(self requiredField: each) ifTrue: [ ^true ].
		each isList ifTrue: [ (self hasRequiredFieldIn: each fields)
			ifTrue: [ ^true ] ] ].
	^false! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'DiegoLont 2/14/2012 14:54'!
hasValidation
	^self builder hasValidation! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'DiegoLont 2/14/2012 14:53'!
hasValidation: aBoolean 
	self builder hasValidation: aBoolean! !

!DEFieldComponent methodsFor: 'initialization' stamp: 'StephanEggermont 5/2/2011 14:56'!
initialize: aBuilder
	self initialize.
	builder := aBuilder! !

!DEFieldComponent methodsFor: 'validation' stamp: 'StephanEggermont 5/2/2011 14:56'!
isValid: aSubject
	aSubject ifNil: [ ^false ].
	(self fieldsFor: aSubject) do: [ :field | 
		(field isValid: aSubject) ifFalse: [ ^false ] ].
	^true! !

!DEFieldComponent methodsFor: 'validation' stamp: 'StephanEggermont 5/2/2011 14:56'!
isValid: aSubject original: original
	" performs the 'isValid' check only if field is changed "
	(self fieldsFor: aSubject) do: [ :field |
		((field value: aSubject) = (field value: original) 
			or: [ (field isValid: aSubject) ]) ifFalse: [ ^false ] ].
	^true! !

!DEFieldComponent methodsFor: 'validation' stamp: 'StephanEggermont 5/2/2011 14:56'!
isValidErrors: aSubject
	| retVal |
	retVal := OrderedCollection new.
	(self fieldsFor: aSubject) do: [ :field | 
			| error | 
			error := (aSubject class perform: field) isValidError: aSubject.
			error ifNotEmpty: [	retVal add: error ] ].
	^retVal! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
panel
	^ panel! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
panel: anObject
	panel := anObject! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
propertySymbol
	^self builder propertySymbol! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
propertySymbol: anObject
	self builder propertySymbol: anObject! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
readonly
	^self builder readonly! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
readonlyField: aField
	^self readonly or: [ aField readonly ]! !

!DEFieldComponent methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:56'!
renderAction: anAction for: aSubject on: canvas
	anAction ifNotNil: [
		anAction renderFor: aSubject on: canvas ]! !

!DEFieldComponent methodsFor: 'rendering' stamp: 'DiegoLont 9/26/2012 15:53'!
renderCompositeField: aField for: aSubject on: canvas 
	self renderRowFor: aSubject field: aField on: canvas.
	self renderRows: ((aField fieldsFor: aSubject) collect: [ :each | self cacheField: each ]) for: aSubject on: canvas! !

!DEFieldComponent methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:56'!
renderContentFor: aSubject on: canvas
	self renderRowsFor: aSubject on: canvas! !

!DEFieldComponent methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:56'!
renderContentFor: aSubject on: canvas fields: fields
	self renderRows: (fields collect: [ :each | self cacheField: each ])
		for: aSubject
		on: canvas! !

!DEFieldComponent methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:56'!
renderDataFor: aSubject field: aField on: canvas
	aField isListField
		ifTrue: [ self renderContentFor: aSubject on: canvas fields: aField fields ]
		ifFalse: [ self renderWidgetFor: aSubject field: aField on: canvas ]! !

!DEFieldComponent methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:56'!
renderInfoFor: aSubject field: aField on: canvas
	aField infoFor: aSubject on: canvas readonly: (self readonlyField: aField)! !

!DEFieldComponent methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:56'!
renderLabelFor: aSubject field: aField on: canvas
	aField labelFor: aSubject readonly: (self readonlyField: aField) on: canvas showBlock: self showBlock.
	self renderRequiredStarFor: aSubject field: aField on: canvas! !

!DEFieldComponent methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:56'!
renderRequiredStarFor: aSubject field: aField on: canvas
	((self readonlyField: aField) not and: [
		self requiredStar and: [ aField required ] ]) ifTrue: [
			canvas span
				class: 'field-required';
				with: '*' ]! !

!DEFieldComponent methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:56'!
renderRowContentFor: aSubject field: aField action: action on: canvas
	self renderLabelFor: aSubject field: aField on: canvas.
	self renderInfoFor: aSubject field: aField on: canvas.
	self renderDataFor: aSubject field: aField on: canvas.
	self renderAction: action for: aSubject on: canvas! !

!DEFieldComponent methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:56'!
renderRowFor: aSubject field: aField on: canvas
	self renderRowContentFor: aSubject field: aField action: (self actionFor: aField) on: canvas! !

!DEFieldComponent methodsFor: 'rendering' stamp: 'DiegoLont 9/26/2012 16:40'!
renderRows: aFieldList for: aSubject on: canvas
	aFieldList do: 
		[ :field | 
		field isComposite ifTrue: [
			self 
				renderCompositeField: field
				for: aSubject
				on: canvas ]
		ifFalse: [
			self 
				renderRowFor: aSubject
				field: field
				on: canvas ] ]! !

!DEFieldComponent methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:56'!
renderRowsFor: aSubject on: canvas
	self renderRows: (self fieldsFor: aSubject) for: aSubject on: canvas! !

!DEFieldComponent methodsFor: 'rendering' stamp: 'DiegoLont 2/14/2012 14:58'!
renderWidgetFor: aSubject field: aField on: canvas
	self hasValidation
		ifTrue: [ aField widgetFor: aSubject on: canvas readonly: (self readonlyField: aField) panel: self panel ]
		ifFalse: [ aField simpleWidgetFor: aSubject on: canvas ]! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
requiredField: aField
	^(self readonlyField: aField) not and: [ aField required ]! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
requiredStar
	^self builder requiredStar! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
requiredStar: aBoolean
	self builder requiredStar: aBoolean! !

!DEFieldComponent methodsFor: 'navigation' stamp: 'StephanEggermont 5/2/2011 14:56'!
show: aSubject field: aField
	self panel show: aSubject field: aField! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
showBlock
	showBlock ifNil: [ 
		self panel ifNotNil: [ ^[ :aSubject :aField | self show: aSubject field: aField ] ] ].
	^showBlock! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
showBlock: aBlock
	showBlock := aBlock! !

!DEFieldComponent methodsFor: 'validation' stamp: 'StephanEggermont 5/2/2011 14:56'!
validate: aSubject
	(self fieldsFor: aSubject) do: [ :each | 
			each validate: aSubject ]! !

!DEFieldComponent methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:56'!
widgetClassFor: aField 
	^ aField requiredClass! !

DEFieldComponent subclass: #DEFieldDivs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside-Component'!

!DEFieldDivs methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:57'!
renderAction: anAction for: aSubject on: canvas
	canvas span
		class: 'fieldAction';
		with: [ anAction ifNotNil: [
			anAction renderFor: aSubject on: canvas ] ]! !

!DEFieldDivs methodsFor: 'rendering' stamp: 'DiegoLont 9/26/2012 16:56'!
renderCompositeField: aField for: aSubject on: canvas
	canvas div
		id: (aField compositeIdOn: canvas updateBlock: [ :html | super renderCompositeField: aField for: aSubject on: html ]) ;
		with: [ super renderCompositeField: aField for: aSubject on: canvas	]! !

!DEFieldDivs methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:57'!
renderInfoFor: aSubject field: aField on: canvas
	canvas span
		class: 'fieldInfo';
		with: [ super renderInfoFor: aSubject field: aField on: canvas ]! !

!DEFieldDivs methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:57'!
renderLabelFor: aSubject field: aField on: canvas
	canvas span
		class: 'fieldLabel';
		with: [ super renderLabelFor: aSubject field: aField on: canvas ]! !

!DEFieldDivs methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:57'!
renderRowFor: aSubject field: aField on: canvas
	| action |
	action := self actionFor: aField. 
	action ifNil: [
		canvas div
			class: 'fieldRow';
			with: [
				self renderRowContentFor: aSubject field: aField action: action on: canvas ]	]
	ifNotNil: [
		action renderBlock: [ :html | self renderRowContentFor: aSubject field: aField action: action on: html ].
		canvas div
			class: 'fieldRow';
			id: (action ensureFieldId: canvas);
			with: [ self renderRowContentFor: aSubject field: aField action: action on: canvas ] ]! !

!DEFieldDivs methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:57'!
renderWidgetFor: aSubject field: aField on: canvas
	canvas span
		class: 'fieldWidget';
		class: (self widgetClassFor: aField);
		with: [ super renderWidgetFor: aSubject field: aField on: canvas ]! !

DEFieldComponent subclass: #DEFieldOverview
	instanceVariableNames: 'first heading separatedBy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside-Component'!

!DEFieldOverview methodsFor: 'initialization' stamp: 'StephanEggermont 5/2/2011 14:57'!
createBuilder
	" een overview is standaard readonly "
	^super createBuilder
		beReadonly;
		yourself! !

!DEFieldOverview methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:57'!
first
	first ifNil: [ ^false ].
	^ first! !

!DEFieldOverview methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:57'!
first: anObject
	first := anObject! !

!DEFieldOverview methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:57'!
heading
	heading ifNil: [ ^false ].
	^ heading! !

!DEFieldOverview methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:57'!
heading: anObject
	heading := anObject! !

!DEFieldOverview methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:57'!
renderContentFor: aSubject on: canvas
	self first: true.
	super renderContentFor: aSubject on: canvas! !

!DEFieldOverview methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:57'!
renderRowContentFor: aSubject field: aField action: action on: canvas
	self renderDataFor: aSubject field: aField on: canvas! !

!DEFieldOverview methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:57'!
renderSeparatorOn: canvas
	self separatedBy
		ifNil: [ canvas break ]
		ifNotNil: [ separatedBy value: canvas ]! !

!DEFieldOverview methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:57'!
renderWidgetFor: aSubject field: aField on: canvas
	(aField hasValueFor: aSubject) ifTrue: [
		self first
			ifTrue: [ self first: false.
				self heading
					ifTrue: [ canvas strong: [ super renderWidgetFor: aSubject field: aField on: canvas ] ]
					ifFalse: [ super renderWidgetFor: aSubject field: aField on: canvas ] ]
			ifFalse: [ 
				self renderSeparatorOn: canvas.
				super renderWidgetFor: aSubject field: aField on: canvas ] ]! !

!DEFieldOverview methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:57'!
separatedBy
	^ separatedBy! !

!DEFieldOverview methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:57'!
separatedBy: anObject
	separatedBy := anObject! !

DEFieldOverview subclass: #DEFieldSpansOverview
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside-Component'!

!DEFieldSpansOverview methodsFor: 'rendering' stamp: 'DiegoLont 8/22/2011 21:47'!
renderWidgetFor: aSubject field: aField on: canvas
	canvas span
		class: aField label;
		with: [ super renderWidgetFor: aSubject field: aField on: canvas ]! !

DEFieldComponent subclass: #DEFieldTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside-Component'!

!DEFieldTable methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:58'!
renderAction: anAction for: aSubject on: canvas
	canvas tableData: [
		super renderAction: anAction for: aSubject on: canvas ]! !

!DEFieldTable methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:58'!
renderContentFor: aSubject on: canvas
	canvas table: [ super renderContentFor: aSubject on: canvas ]! !

!DEFieldTable methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:58'!
renderContentFor: aSubject on: canvas fields: fields
	canvas table: [ super renderContentFor: aSubject on: canvas fields: fields ]! !

!DEFieldTable methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:58'!
renderInfoFor: aSubject field: aField on: canvas
	canvas tableData: [ super renderInfoFor: aSubject field: aField on: canvas ]! !

!DEFieldTable methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:58'!
renderLabelFor: aSubject field: aField on: canvas
	canvas tableData: [ super renderLabelFor: aSubject field: aField on: canvas ]! !

!DEFieldTable methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 15:50'!
renderRowFor: aSubject field: aField on: canvas
	| action |
	action := self actionFor: aField. 
	(action isNil or: [ action isKindOf: DEFieldButton ])
		ifTrue: [
			canvas tableRow: [
				self renderRowContentFor: aSubject field: aField action: action on: canvas ] ]
		ifFalse: [
			action renderBlock: [ :html |
				self renderRowContentFor: aSubject field: aField action: action on: html ].
			canvas tableRow
				id: (action ensureFieldId: canvas);
				with: [ self renderRowContentFor: aSubject field: aField action: action on: canvas ] ]! !

!DEFieldTable methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:58'!
renderWidgetFor: aSubject field: aField on: canvas
	canvas tableData
		class: (self widgetClassFor: aField);
		with: [ super renderWidgetFor: aSubject field: aField on: canvas ]! !

WAComponent subclass: #DEPanel
	instanceVariableNames: 'pages pageInfoData title divId divClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside-Component'!

DEPanel subclass: #DEEditPanel
	instanceVariableNames: 'form cancelButton saveButton requiredText'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside-Component'!

!DEEditPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:53'!
addSubject: aSubject isNew: aIsNew
	self addPage: (DEEditComponent new
		subject: aSubject isNew: aIsNew;
		yourself)! !

!DEEditPanel methodsFor: 'navigation' stamp: 'StephanEggermont 5/2/2011 15:00'!
answerOk
	self answer: (self pages collect: [ :page | page selected ])! !

!DEEditPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
cancelButton
	^cancelButton ifNil: [ cancelButton := self createCancelButton ]! !

!DEEditPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
cancelText
	self cancelButton label! !

!DEEditPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
cancelText: anObject
	self cancelButton label: anObject! !

!DEEditPanel methodsFor: 'initialization' stamp: 'StephanEggermont 5/2/2011 15:53'!
createButton
	^DEActionButton new! !

!DEEditPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
createCancelButton
	^self createButton
		label: 'Cancel';
		action: [ self doCancel ];
		yourself! !

!DEEditPanel methodsFor: 'initialization' stamp: 'StephanEggermont 5/2/2011 15:53'!
createForm
	^DEFormDecoration new! !

!DEEditPanel methodsFor: 'navigation' stamp: 'StephanEggermont 5/2/2011 15:00'!
doCancel
	self answer: nil! !

!DEEditPanel methodsFor: 'navigation' stamp: 'StephanEggermont 5/2/2011 15:00'!
doSave
	" check if all pages have a valid answer "
	self pages do: [ :page | page validate ].
	self pages 
		detect: [ :page | page isValid not ]
		ifNone: [ self answerOk ]
! !

!DEEditPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
form
	^form ifNil: [ form := self createForm ]! !

!DEEditPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
hasRequiredField
	self pages do: [ :each | each hasRequiredField ifTrue: [ ^true ] ].
	^false! !

!DEEditPanel methodsFor: 'initialization' stamp: 'StephanEggermont 5/2/2011 15:00'!
initialize
	super initialize.
	self addDecoration: self form.
	self updateButtons! !

!DEEditPanel methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 15:00'!
renderContentOn: canvas
	super renderContentOn: canvas.
	self renderRequiredTextOn: canvas! !

!DEEditPanel methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 15:00'!
renderRequiredTextOn: canvas
	self requiredText ifNotNil: [
		self hasRequiredField ifTrue: [
			canvas div
				class: self requiredClass;
				with: [
					canvas span
						class: 'field-required';
						with: '*'.
					canvas render: self requiredText ] ] ]! !

!DEEditPanel methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 15:00'!
requiredClass
	^'requiredText'! !

!DEEditPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
requiredText
	^ requiredText! !

!DEEditPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
requiredText: anObject
	requiredText := anObject! !

!DEEditPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
saveButton
	^saveButton ifNil: [ saveButton := self createButton
			label: 'Save';
			action: [ self doSave ];
			yourself ]! !

!DEEditPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
saveText
	self saveButton label! !

!DEEditPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
saveText: anObject
	self saveButton label: anObject! !

!DEEditPanel methodsFor: 'initialization' stamp: 'StephanEggermont 5/2/2011 15:00'!
updateButtons
	self form defaultButton: self saveButton.
	self form addButton: self cancelButton.

! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:52'!
addPage: page
	self addPage: page info: DEPageInfo new
! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:52'!
addPage: page class: aClass
	self addPage: page info: 
		(DEPageInfo new
			divClass: aClass;
			yourself)
! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:52'!
addPage: page id: anId
	self addPage: page info: 
		(DEPageInfo new
			divId: anId;
			yourself)
! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:52'!
addPage: page id: anId class: aClass
	self addPage: page info: 
		(DEPageInfo new
			divId: anId;
			divClass: aClass;
			yourself)
! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
addPage: aPage info: aPageInfo
	self pages detect: [
		:each| each = aPage
	] ifNone: [
		self pages add: aPage.
		self pageInfoData at: aPage put: aPageInfo
	].! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
children
	^self pages
! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
clearPages
	pages := nil
! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
divClass
	^ divClass! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
divClass: anObject
	divClass := anObject! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
divId
	^ divId! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
divId: anObject
	divId := anObject! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
pageInfoData
	^ pageInfoData ifNil: [ pageInfoData := Dictionary new ]! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
pages
	^pages ifNil: [ pages := OrderedCollection new ]
! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
removePage: aPage
	(self pages contains: [
		:each| each = aPage
	]) ifTrue: [
		self pages remove: aPage.
		self pageInfoData removeKey: aPage
	]
! !

!DEPanel methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 15:00'!
renderContentOn: canvas
	self renderTitleOn: canvas.
	(divId isNil and: [ divClass isNil ])
		ifTrue: [ self renderPagesOn: canvas ]
		ifFalse: [ self renderDivOn: canvas ]
! !

!DEPanel methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 15:00'!
renderDivOn: canvas
	| brush | 
	brush := canvas div.
	divId ifNotNil: [ brush id: divId ].
	divClass ifNotNil: [ brush class: divClass ].
	brush with: [ self renderPagesOn: canvas ]
! !

!DEPanel methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 15:00'!
renderPagesOn: canvas
	self pages do: [:each|
		(self pageInfoData at: each) renderPage: each on: canvas ]
! !

!DEPanel methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 15:00'!
renderTitleOn: canvas
	self title ifNotNil: [ canvas heading
			level: 2;
			with: self title
		]! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
setInfo: aPageInfo for: aPage 
	self pageInfoData 
		at: aPage
		put: aPageInfo! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
states
	^Array with: self
! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
title
	^title! !

!DEPanel methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:00'!
title: anObject
	title := anObject! !

DEPanel subclass: #DESearchCombiner
	instanceVariableNames: 'criteriaTitle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside-Component'!

!DESearchCombiner methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:59'!
canSearch
	self pages do: [ :page |
		page canSearch ifTrue: [ ^true ] ].
	^false! !

!DESearchCombiner methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:59'!
clearFields
	self pages do: [ :page | page clearFields ]! !

!DESearchCombiner methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:59'!
criteriaTitle
	^ criteriaTitle! !

!DESearchCombiner methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:59'!
criteriaTitle: anObject
	criteriaTitle := anObject! !

!DESearchCombiner methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:59'!
filter: aCollection
	self canSearch ifTrue: [ 
		| retVal |
		retVal := aCollection.
		self pages do: [ :page |
			page canSearch ifTrue: [ retVal := page filter: retVal ] ].
		^retVal ].
	^aCollection! !

!DESearchCombiner methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:59'!
formId: aFormId
	self pages do: [ :each | each formId: aFormId ]! !

!DESearchCombiner methodsFor: 'rendering' stamp: 'DiegoLont 8/22/2011 16:59'!
renderCriteriaOn: canvas
	self canSearch ifTrue: [
		self criteriaTitle ifNotNil: [
			canvas heading
				level: 3;
				with: self criteriaTitle ].
		self pages do: [ :each | each renderCriteriaOn: canvas ] ]! !

!DESearchCombiner methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:59'!
searchBlock: aBlock
	self pages do: [ :each | each searchBlock: aBlock ]! !

DEPanel subclass: #DESearchPanel
	instanceVariableNames: 'searchLabel resultsBlock target accessor actionButton form clearButton clearLabel canClear'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside-Component'!

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
accessor
	accessor ifNil: 
		[ ^ #() ].
	^accessor! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
accessor: anArray 
	accessor := anArray! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
actionButton
	^actionButton ifNil: [ actionButton := self createActionButton ]! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
actionButton: aButton
	actionButton := aButton! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
addPage: page info: info
	page formId: self formId.
	super addPage: page info: info.
	page searchBlock: [ self search ]! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
allValues
	| retVal |
	retVal := self target.
	self accessor do: [ :each | retVal := retVal perform: each ].
	^ retVal! !

!DESearchPanel methodsFor: 'initialization' stamp: 'DiegoLont 10/2/2012 09:21'!
canClear
	canClear ifNil: [ ^clearLabel notNil ].
	^canClear! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 10/2/2012 09:18'!
canClear: aBoolean
	canClear := aBoolean.
	self updateButtons! !

!DESearchPanel methodsFor: 'searching' stamp: 'DiegoLont 8/22/2011 16:58'!
canSearch
	self pages do: [ :page |
		page canSearch ifTrue: [ ^true ] ].
	^false! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
clearButton
	^clearButton ifNil: [ clearButton := self createClearButton ]! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
clearFields
	self pages do: [ :page | page clearFields ]! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
clearLabel
	^clearLabel! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 10/2/2012 09:21'!
clearLabel: aString
	clearLabel := aString.
	self clearButton label: aString! !

!DESearchPanel methodsFor: 'initialization' stamp: 'DiegoLont 8/22/2011 16:58'!
createActionButton
	^self createButton
		action: [ self search ];
		label: self searchLabel;
		yourself! !

!DESearchPanel methodsFor: 'initialization' stamp: 'DiegoLont 2/3/2012 14:03'!
createButton
	^DEActionButton new! !

!DESearchPanel methodsFor: 'initialization' stamp: 'DiegoLont 8/22/2011 16:58'!
createClearButton
	^self createButton
		action: [ self clearFields ];
		beCancelAction;
		label: self clearLabel;
		yourself! !

!DESearchPanel methodsFor: 'initialization' stamp: 'DiegoLont 2/3/2012 14:03'!
createForm
	^DEFormDecoration new! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
form
	^form ifNil: [ form := self createForm ]! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
formClass
	^form formClass! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
formClass: aString
	^form formClass: aString! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
formId
	^form formId! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
formId: aString
	form formId: aString.
	self pages do: [ :each |
		each formId: aString ].! !

!DESearchPanel methodsFor: 'initialization' stamp: 'DiegoLont 8/22/2011 16:58'!
initialize
	super initialize.
	self addDecoration: self form.
	self updateButtons! !

!DESearchPanel methodsFor: 'rendering' stamp: 'DiegoLont 8/22/2011 16:58'!
renderButtonsOn: canvas 
	self actionButton
		renderOn: canvas
! !

!DESearchPanel methodsFor: 'rendering' stamp: 'DiegoLont 8/22/2011 16:58'!
renderCriteriaOn: canvas
	self pages do: [ :each | each renderCriteriaOn: canvas ]! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
resultsBlock
	resultsBlock ifNil: [ ^[ :results | self answer: results ] ].
	^resultsBlock! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
resultsBlock: anObject
	resultsBlock := anObject! !

!DESearchPanel methodsFor: 'searching' stamp: 'DiegoLont 2/7/2012 14:05'!
search
	self canSearch ifTrue: [ 
		| retVal |
		retVal := self allValues.
		self pages do: [ :page |
			page canSearch ifTrue: [ retVal := page filter: retVal ] ].
		self resultsBlock value: retVal ]! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
searchLabel
	searchLabel ifNil: [ ^'Search' ].
	^searchLabel! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
searchLabel: aString 
	searchLabel := aString.
	self actionButton label: aString! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
target
	^target! !

!DESearchPanel methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:58'!
target: aTarget
	target := aTarget! !

!DESearchPanel methodsFor: 'initialization' stamp: 'DiegoLont 10/2/2012 09:18'!
updateButtons
	self form defaultButton: self actionButton.
	self canClear
		ifTrue: [ self form addButton: self clearButton ]
		ifFalse: [ self form removeButton: self clearButton ]! !

WAComponent subclass: #DESearchComponent
	instanceVariableNames: 'formId formClass title subject propertySymbol fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside-Component'!

DESearchComponent subclass: #DEDetailedSearchComponent
	instanceVariableNames: 'searchData'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside-Component'!

!DEDetailedSearchComponent methodsFor: 'searching' stamp: 'DiegoLont 8/22/2011 16:52'!
canSearch
	self fields do: [ :field |
		| value |
		value := self searchData at: field.
		(field isValidSearchValue: value) ifTrue: [ ^true ] ].
	^false
! !

!DEDetailedSearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:52'!
clearFields
	searchData := nil.
	fields := nil! !

!DEDetailedSearchComponent methodsFor: 'initialization' stamp: 'DiegoLont 2/3/2012 13:45'!
createFields
	| retVal |
	retVal := OrderedCollection new.
	(subject perform: self propertySymbol) do: [ :each|
		|field|
		each isSymbol
			ifTrue: [ field := (subject perform: each) ]
			ifFalse: [ field := each ].
		retVal add: field
	].
	^retVal! !

!DEDetailedSearchComponent methodsFor: 'initialization' stamp: 'DiegoLont 8/22/2011 16:52'!
createSearchData
	| retVal |
	retVal := Dictionary new.
	fields do: [ :each | retVal at: each put: nil ].
	^retVal! !

!DEDetailedSearchComponent methodsFor: 'searching' stamp: 'DiegoLont 8/22/2011 16:52'!
hasMatch: aSubject
	self fields do: [ :each|
		| value |
		value := searchData at: each.
		(each isValidSearchValue: value)
			ifTrue: [ (each find: value in: aSubject) ifFalse: [ ^false ] ] ].
	^true
! !

!DEDetailedSearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:52'!
isFieldMulti: aField
	^aField isMulti: (self searchData at: aField)! !

!DEDetailedSearchComponent methodsFor: 'rendering' stamp: 'DiegoLont 2/6/2012 15:41'!
renderCriteriaOn: canvas 
	canvas table: [
		canvas tableRow.
		self fields do: [ :field | 
			| value |
			value := self searchData at: field.
			(field isValidSearchValue: value) ifTrue: [
				field 
					renderReadonlyTableRowOn: canvas
					values: self searchData ] ] ]! !

!DEDetailedSearchComponent methodsFor: 'rendering' stamp: 'DiegoLont 2/3/2012 13:51'!
renderField: field on: canvas 
	| action |
	self formId
		ifNil: [ action := nil ]
		ifNotNil: [ action := field searchAction ].
	action ifNotNil: [
		action
			formId: self formId;
			action: [ self switchMultiFor: field ];
			multiBlock: [ self isFieldMulti: field ]
		].
	field 
		renderTableRowOn: canvas
		values: self searchData
		action: action! !

!DEDetailedSearchComponent methodsFor: 'rendering' stamp: 'DiegoLont 8/22/2011 16:52'!
renderSearchTableOn: canvas 
	canvas div
		class: self formClass;
		with: 
			[ canvas table: 
				[ canvas tableRow.
				self fields do: 
					[ :field | 
					self renderField: field on: canvas ] ] ]! !

!DEDetailedSearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:52'!
searchData
	^searchData ifNil: [ searchData := self createSearchData ]! !

!DEDetailedSearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:52'!
switchMultiFor: aField
	self searchData at: aField put: (aField switchValue: (self searchData at: aField))! !

DEDetailedSearchComponent subclass: #DEIndirectSearchComponent
	instanceVariableNames: 'accessor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside-Component'!

!DEIndirectSearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:53'!
accessor
	^ accessor! !

!DEIndirectSearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:53'!
accessor: anObject
	accessor := anObject! !

!DEIndirectSearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:53'!
collectionOf: aSubject
	| retVal |
	retVal := aSubject.
	self accessor do: [ :each |
		retVal := retVal perform: each ].
	^retVal ! !

!DEIndirectSearchComponent methodsFor: 'searching' stamp: 'DiegoLont 8/22/2011 16:53'!
hasMatch: aSubject
	(self collectionOf: aSubject) do: [ :each |
		(self hasMatch: aSubject for: each) ifTrue: [ ^true ] ].
	^false
! !

!DEIndirectSearchComponent methodsFor: 'searching' stamp: 'DiegoLont 8/22/2011 16:53'!
hasMatch: aSubject for: anElement
	self fields do: [ :each|
		| value |
		value := searchData at: each.
		(each isValidSearchValue: value)
			ifTrue: [ (each find: value in: anElement) ifFalse: [ ^false ] ] ].
	^true
! !

DESearchComponent subclass: #DEFastSearchComponent
	instanceVariableNames: 'searchValue searchLabel searchBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside-Component'!

!DEFastSearchComponent methodsFor: 'searching' stamp: 'DiegoLont 2/7/2012 14:02'!
canSearch
	^self searchValue notEmpty! !

!DEFastSearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:54'!
clearFields
	searchValue := nil.
	fields := nil! !

!DEFastSearchComponent methodsFor: 'initialization' stamp: 'DiegoLont 3/12/2012 14:58'!
createFields
	| retVal |
	retVal := OrderedCollection new.
	(subject perform: propertySymbol) do: [ :each|
		|field|
		each isSymbol
			ifTrue: [ field := (subject perform: each) ]
			ifFalse: [ field := each ].
		retVal add: field.
	].
	^retVal! !

!DEFastSearchComponent methodsFor: 'searching' stamp: 'DiegoLont 3/12/2012 14:58'!
hasMatch: aSubject
	searchValue ifNil: [ ^false. ].
	self fields do: [ :field | 
		(field find: searchValue in: aSubject) ifTrue: [ ^true ] ].
	^false
! !

!DEFastSearchComponent methodsFor: 'rendering' stamp: 'DiegoLont 8/22/2011 16:57'!
renderCriteriaOn: canvas
	canvas span: self searchLabel.
	canvas span: self searchValue! !

!DEFastSearchComponent methodsFor: 'rendering' stamp: 'DiegoLont 8/22/2011 16:54'!
renderSearchTableOn: canvas 
	canvas div
		class: self formClass;
		with: 
			[ canvas table: 
				[ canvas tableRow: 
					[ canvas tableData: [ canvas label: self searchLabel ].
					canvas tableData: 
						[ canvas textInput 
							on: #searchValue
							of: self ] ] ].
			canvas break ]! !

!DEFastSearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 2/7/2012 14:04'!
search
	self searchBlock ifNotNil: [ self searchBlock value ]
! !

!DEFastSearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:54'!
searchBlock
	^ searchBlock! !

!DEFastSearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 2/7/2012 14:04'!
searchBlock: anObject
	searchBlock := anObject! !

!DEFastSearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:54'!
searchLabel
	searchLabel ifNil: [ ^'Search:' ].
	^ searchLabel! !

!DEFastSearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:54'!
searchLabel: anObject
	searchLabel := anObject! !

!DEFastSearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:54'!
searchValue
	searchValue ifNil: [ ^'' ].
	^searchValue! !

!DEFastSearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:54'!
searchValue: aString
	searchValue := aString.
	self canSearch
		ifTrue: [ self search ]
! !

!DESearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:48'!
canSearch
	^self subclassResponsibility! !

!DESearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:48'!
clearFields
! !

!DESearchComponent methodsFor: 'initialization' stamp: 'DiegoLont 8/22/2011 16:48'!
createFields! !

!DESearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:48'!
fields
	fields ifNil: [ fields := self createFields ].
	^fields! !

!DESearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:48'!
fields: anObject
	fields := anObject! !

!DESearchComponent methodsFor: 'searching' stamp: 'DiegoLont 8/22/2011 16:48'!
filter: aCollection
	self canSearch 
		ifTrue: [ ^aCollection select: [ :each| self hasMatch: each ] ]
		ifFalse: [ ^aCollection ]! !

!DESearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:48'!
formClass
	formClass ifNil: [ ^'search-form-data' ].
	^formClass! !

!DESearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:48'!
formClass: aString
	formClass := aString
! !

!DESearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:48'!
formId
	^ formId! !

!DESearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:48'!
formId: anObject
	formId := anObject! !

!DESearchComponent methodsFor: 'searching' stamp: 'DiegoLont 8/22/2011 16:48'!
hasMatch: aSubject
	^self subclassResponsibility! !

!DESearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:48'!
propertySymbol
	propertySymbol ifNil: [ ^#fields ].
	^ propertySymbol! !

!DESearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:48'!
propertySymbol: anObject
	propertySymbol := anObject.
	self clearFields! !

!DESearchComponent methodsFor: 'rendering' stamp: 'DiegoLont 8/22/2011 16:48'!
renderContentOn: canvas 
	title ifNotNil: 
		[ canvas heading
			level: 2;
			with: title ].
	self renderSearchTableOn: canvas! !

!DESearchComponent methodsFor: 'rendering' stamp: 'DiegoLont 8/22/2011 16:48'!
renderCriteriaOn: canvas
	self subclassResponsibility! !

!DESearchComponent methodsFor: 'rendering' stamp: 'DiegoLont 8/22/2011 16:48'!
renderSearchTableOn: canvas
	self subclassResponsibility! !

!DESearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:48'!
searchBlock: anObject! !

!DESearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:48'!
subject
	^ subject! !

!DESearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:48'!
subject: anObject
	subject = anObject ifFalse: [
		self clearFields.
		subject := anObject]! !

!DESearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:48'!
title
	^ title! !

!DESearchComponent methodsFor: 'accessing' stamp: 'DiegoLont 8/22/2011 16:48'!
title: anObject
	title := anObject! !

Object subclass: #DEBuilder
	instanceVariableNames: 'subject propertySymbol readonly customActions customUpdaters panel requiredStar fields hasValidation customColumns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside'!

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
addCustomAction: actionButton
	self customActions at: actionButton key put: actionButton! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
addCustomAction: actionButton at: aKey
	self customActions at: aKey put: actionButton! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
addCustomUpdater: anUpdater
	self customUpdaters at: anUpdater fieldSymbol put: anUpdater! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
beReadonly
	readonly := true! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
beWritable
	readonly := false! !

!DEBuilder methodsFor: 'initialization' stamp: 'StephanEggermont 5/2/2011 14:45'!
create: aSubject from: aCollection
	|temp|
	temp := aSubject new.
	aSubject fields with: aCollection do: [:each :text| |field|
		field := (aSubject perform: each).
		temp perform: (field accessor asMutator) with: (field convertFromString: text)].
	^temp! !

!DEBuilder methodsFor: 'component building' stamp: 'StephanEggermont 5/2/2011 15:34'!
createDivsComponent
	^DEFieldDivs on: self! !

!DEBuilder methodsFor: 'component building' stamp: 'StephanEggermont 5/2/2011 15:34'!
createTableComponent
	^DEFieldTable on: self! !

!DEBuilder methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 10:24'!
createTitleReport
	|retVal columns|
	columns := OrderedCollection new
		add: (DEReportColumn new
			valueBlock: [ :row | row ];
			formatBlock: [ :value :canvas | canvas image
				url: value noIconUrl ];
			yourself);
		add: (DEDivColumn new
			valueBlock: [ :row | row noTitle ];
			yourself);
		yourself.
	self customColumns do: [ :each | columns add: each ].		
	retVal := DEDivReport new
		columns: columns;
		reportClass: 'no-report-title';
		yourself.
	retVal rowPeriod: 1.
	^retVal.! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
customActionFor: aKey
	^self customActionFor: aKey ifAbsent: [ nil ]! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
customActionFor: aKey ifAbsent: aBlock
	^self customActions at: aKey ifAbsent: aBlock! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
customActions
	^customActions ifNil: [ customActions := Dictionary new ]! !

!DEBuilder methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 10:25'!
customColumns
	^customColumns ifNil: [ customColumns := OrderedCollection new ]! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
customUpdaterFor: aKey
	^self customUpdaters at: aKey ifAbsent: [ nil ]! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
customUpdaters
	^customUpdaters ifNil: [ customUpdaters := Dictionary new ]! !

!DEBuilder methodsFor: 'accessing' stamp: 'DiegoLont 12/21/2011 17:36'!
fields
	fields ifNil: [ ^(self subject perform: self propertySymbol) collect: [ :each | self subject perform: each ]].
	^fields! !

!DEBuilder methodsFor: 'accessing' stamp: 'DiegoLont 12/21/2011 17:35'!
fields: anObject
	fields := anObject! !

!DEBuilder methodsFor: 'accessing' stamp: 'DiegoLont 2/14/2012 14:54'!
hasValidation
	hasValidation ifNil: [ ^true ].
	^hasValidation! !

!DEBuilder methodsFor: 'accessing' stamp: 'DiegoLont 2/14/2012 14:53'!
hasValidation: aBoolean 
	hasValidation := aBoolean! !

!DEBuilder methodsFor: 'import' stamp: 'StephanEggermont 5/2/2011 15:36'!
importColumnsFor: aSubject
	|columns|
	columns := OrderedCollection new.
	aSubject fields do: [:field ||fld|
		fld := (aSubject perform: field) .
		columns add: ((DEReportColumn new)
			title: (fld label);
			selector: (fld accessor);
			yourself
			)].
	^columns! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
panel
	^ panel! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
panel: anObject
	panel := anObject! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
propertySymbol
	propertySymbol ifNil: [
		self readonly ifFalse: [ ^#editFields ].
		^#fields ].
	^ propertySymbol! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
propertySymbol: anObject
	propertySymbol := anObject! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
propertySymbolWithDefault: aSymbol
	propertySymbol ifNil: [^aSymbol].
	^self propertySymbol! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
readonly
	^readonly ifNil: [ readonly := false ]! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
removeCustomActions
	customActions := nil! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
requiredStar
	requiredStar ifNil: [ ^false ].
	^ requiredStar! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
requiredStar: anObject
	requiredStar := anObject! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
subject
	^ subject! !

!DEBuilder methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:45'!
subject: anObject
	subject := anObject! !

Object subclass: #DEButton
	instanceVariableNames: 'label isCancel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside'!

DEButton subclass: #DEActionButton
	instanceVariableNames: 'action condition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside'!

!DEActionButton methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
action
	^ action! !

!DEActionButton methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
action: anObject
	action := anObject! !

!DEActionButton methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2012 15:50'!
condition
	^ condition! !

!DEActionButton methodsFor: 'accessing' stamp: 'DiegoLont 9/17/2012 15:50'!
condition: anObject
	condition := anObject! !

!DEActionButton methodsFor: 'performing' stamp: 'DiegoLont 2/22/2012 10:32'!
perform
	self action value! !

!DEActionButton methodsFor: 'rendering' stamp: 'DiegoLont 9/17/2012 15:50'!
renderButtonOn: canvas
	self renderButtonOn: canvas callback: [ self perform ]
! !

!DEActionButton methodsFor: 'rendering' stamp: 'DiegoLont 9/17/2012 15:53'!
renderButtonOn: canvas callback: aCallback
	(self condition isNil or: [ self condition value ]) ifTrue: [
		(self buttonOn: canvas)
			callback: aCallback;
			with: self label ]! !

!DEActionButton methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 15:02'!
renderFor: aSubject on: canvas 
	self renderButtonOn: canvas callback: [ action value: aSubject ]! !

DEActionButton subclass: #DEFieldButton
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside'!

!DEFieldButton methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:48'!
key
	^ key! !

!DEFieldButton methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:48'!
key: anObject
	key := anObject! !

!DEButton methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
beCancelAction
	isCancel := true! !

!DEButton methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
beSubmitAction
	isCancel := false! !

!DEButton methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 15:02'!
buttonOn: canvas
	self isCancel ifTrue: [ ^canvas cancelButton ].
	^canvas submitButton! !

!DEButton methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
isCancel
	isCancel ifNil: [ ^false ].
	^isCancel! !

!DEButton methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
label
	^ label! !

!DEButton methodsFor: 'accessing' stamp: 'DiegoLont 8/26/2012 15:12'!
label: anObject
	label := anObject! !

!DEButton methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
renderButtonOn: canvas
	(self buttonOn: canvas)
		with: self label! !

!DEButton methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
renderOn: canvas
	self renderButtonOn: canvas
! !

Object subclass: #DEPageInfo
	instanceVariableNames: 'divClass divId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside'!

!DEPageInfo methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:59'!
divClass
	^ divClass! !

!DEPageInfo methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:59'!
divClass: anObject
	divClass := anObject! !

!DEPageInfo methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:59'!
divId
	^ divId! !

!DEPageInfo methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 14:59'!
divId: anObject 
	divId := anObject! !

!DEPageInfo methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 14:59'!
renderPage: aPage on: canvas
	| brush |
	brush := canvas div.
	self divId ifNotNil: [ brush id: self divId ].
	self divClass ifNotNil: [ brush class: self divClass ].
	brush with: [ canvas render: aPage ]! !

Object subclass: #DEReportBuilder
	instanceVariableNames: 'builder customColumns sorted'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside'!

!DEReportBuilder methodsFor: 'accessing' stamp: 'DiegoLont 4/3/2012 15:42'!
addCustomColumn: aColumn 
	self customColumns add: aColumn! !

!DEReportBuilder methodsFor: 'accessing' stamp: 'DiegoLont 4/3/2012 15:45'!
addCustomUpdater: anUpdater
	self builder addCustomUpdater: anUpdater! !

!DEReportBuilder methodsFor: 'accessing' stamp: 'DiegoLont 4/3/2012 16:00'!
builder
	^ builder ifNil: [ builder := DEBuilder new ]! !

!DEReportBuilder methodsFor: 'report building' stamp: 'DiegoLont 4/3/2012 15:51'!
createDivReportFrom: aSourceComponent
	|retVal columns sortColumn reverse first|
	sortColumn := nil.
	columns := OrderedCollection new.
	reverse := false.
	first := true. 
	self fields do: [ :field |
		| column |
		column := field createColumn.
		first ifTrue: [
			column clickBlock: [ :row | aSourceComponent showDetails: row ] ].
		field isSorted ifTrue: [
			sortColumn := column.
			reverse := field reverse ].
		columns add: column.
		first := false ].
	self customColumns do: [ :each | columns add: each ].		
	retVal := DEDivReport new
		columns: columns;
		yourself.
	self sorted ifTrue: [
		sortColumn ifNotNil: [
			retVal sortColumn: sortColumn.
			reverse ifTrue: [ retVal reverse ] ] ].
	retVal rowPeriod: 1.
	^retVal! !

!DEReportBuilder methodsFor: 'report building' stamp: 'DiegoLont 4/3/2012 15:52'!
createReport
	| retVal columns sortColumn reverse |
	sortColumn := nil.
	columns := OrderedCollection new.
	reverse := false.
	self fields do: [ :field |
		| column |
		column := field createColumn.
		field isSorted ifTrue: [
			sortColumn := column.
			reverse := field reverse ].
		columns add: column ].
	self customColumns do: [ :each | columns add: each ].		
	retVal := DETableReport new
		columns: columns;
		yourself.
	self sorted ifTrue: [
		sortColumn ifNotNil: [
			retVal sortColumn: sortColumn.
			reverse ifTrue: [ retVal reverse ] ] ].
	retVal rowPeriod: 1.
	^retVal! !

!DEReportBuilder methodsFor: 'report building' stamp: 'DiegoLont 4/3/2012 15:52'!
createReportFrom: aSourceComponent
	|retVal columns sortColumn reverse first|
	sortColumn := nil.
	columns := OrderedCollection new.
	reverse := false.
	first := true. 
	self fields do: [ :field |
		| column |
		column := field createColumn.
		first ifTrue: [
			column clickBlock: [ :row | aSourceComponent showDetails: row ] ].
		field isSorted ifTrue: [
			sortColumn := column.
			reverse := field reverse ].
		columns add: column.
		first := false ].
	self customColumns do: [ :each | columns add: each ].		
	retVal := DETableReport new
		columns: columns;
		yourself.
	self sorted ifTrue: [
		sortColumn ifNotNil: [
			retVal sortColumn: sortColumn.
			reverse ifTrue: [ retVal reverse ] ] ].
	retVal rowPeriod: 1.
	^retVal! !

!DEReportBuilder methodsFor: 'report building' stamp: 'DiegoLont 4/3/2012 15:54'!
createReportFrom: aSourceComponent accessor: aDetailsAccessor
	|retVal columns sortColumn reverse first|
	sortColumn := nil.
	columns := OrderedCollection new.
	reverse := false.
	first := true. 
	self fields do: [ :field |
		| column |
		column := field createColumn.
		first ifTrue: [
			column clickBlock: [ :row | aSourceComponent perform: aDetailsAccessor with: row ] ].
		field isSorted ifTrue: [
			sortColumn := column.
			reverse := field reverse ].
		columns add: column.
		first := false ].
	self customColumns do: [ :each | columns add: each ].		
	retVal := DETableReport new
		columns: columns;
		yourself.
	self sorted ifTrue: [
		sortColumn ifNotNil: [
			retVal sortColumn: sortColumn.
			reverse ifTrue: [ retVal reverse ] ] ].
	retVal rowPeriod: 1.
	^retVal! !

!DEReportBuilder methodsFor: 'accessing' stamp: 'DiegoLont 4/3/2012 15:42'!
customColumns
	^customColumns ifNil: [ customColumns := OrderedCollection new ].
! !

!DEReportBuilder methodsFor: 'accessing' stamp: 'DiegoLont 4/3/2012 15:51'!
fields
	^self builder fields! !

!DEReportBuilder methodsFor: 'accessing' stamp: 'DiegoLont 4/3/2012 15:48'!
keepOrder
	sorted := false.! !

!DEReportBuilder methodsFor: 'accessing' stamp: 'DiegoLont 4/3/2012 15:49'!
propertySymbol
	^self builder propertySymbol! !

!DEReportBuilder methodsFor: 'accessing' stamp: 'DiegoLont 4/3/2012 15:48'!
propertySymbol: anObject
	self builder propertySymbol: anObject! !

!DEReportBuilder methodsFor: 'accessing' stamp: 'DiegoLont 4/3/2012 15:42'!
removeCustomActions
	customActions := nil! !

!DEReportBuilder methodsFor: 'accessing' stamp: 'DiegoLont 4/3/2012 15:42'!
sorted
	^sorted ifNil: [ sorted := true. ].! !

!DEReportBuilder methodsFor: 'accessing' stamp: 'DiegoLont 4/3/2012 15:59'!
subject: aSubject 
	self builder subject: aSubject! !

WADecoration subclass: #DEFormDecoration
	instanceVariableNames: 'formId formClass buttons defaultButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deltawerken-Seaside'!

!DEFormDecoration class methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 5/2/2011 15:51'!
on: component save: saveText cancel: cancelText
	^self new
		addButton: (DEActionButton new
			label: saveText;
			action: [ component doSave ];
			yourself);
		addButton: (DEActionButton new
			label: cancelText;
			beCancelAction;
			action: [ component doCancel ];
			yourself);
		yourself! !

!DEFormDecoration methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
addButton: aButton
	self buttons 
		detect: [ :button | button = aButton ]
		ifNone: [ self buttons add: aButton ]! !

!DEFormDecoration methodsFor: 'accessing' stamp: 'DiegoLont 12/14/2012 14:50'!
addButtonFirst: aButton
	self removeButton: aButton.
	self buttons addFirst: aButton! !

!DEFormDecoration methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
buttons
	^ buttons ifNil: [ buttons := OrderedCollection new ]! !

!DEFormDecoration methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
buttons: anObject
	buttons := anObject! !

!DEFormDecoration methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
defaultButton
	^ defaultButton! !

!DEFormDecoration methodsFor: 'accessing' stamp: 'DiegoLont 12/14/2012 14:49'!
defaultButton: anObject
	defaultButton ifNotNil: [ self removeButton: defaultButton ].
	defaultButton := anObject.
	self addButtonFirst: defaultButton! !

!DEFormDecoration methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
formClass
	^ formClass! !

!DEFormDecoration methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
formClass: anObject
	formClass := anObject! !

!DEFormDecoration methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
formId
	^ formId! !

!DEFormDecoration methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
formId: anObject
	formId := anObject! !

!DEFormDecoration methodsFor: 'accessing' stamp: 'StephanEggermont 5/2/2011 15:02'!
removeButton: aButton
	self buttons remove: aButton ifAbsent: []! !

!DEFormDecoration methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 15:02'!
renderButtonsOn: canvas
	canvas horizontalRule.
	self buttons do: [ :each | each renderOn: canvas ]
! !

!DEFormDecoration methodsFor: 'rendering' stamp: 'StephanEggermont 5/2/2011 15:02'!
renderContentOn: html
	| form |
	form := html form.
	self formId ifNotNil: [ form id: self formId ].
	self formClass ifNotNil: [ form class: self formClass ].
	form with: [
			self renderNextOn: html.
			self renderButtonsOn: html ]! !
